/*
 * ShutdownWorkerOperation.hpp
 *
 *  Created on: Mar 04, 2012
 *      Author: heber
 */

#ifndef FRAGMENTCONTROLLER_SHUTDOWNWORKEROPERATION_HPP_
#define FRAGMENTCONTROLLER_SHUTDOWNWORKEROPERATION_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <boost/asio.hpp>
#include <string>
#include <vector>

#include "Connection.hpp"

#include "Controller/Commands/SyncOperation.hpp"
#include "Jobs/FragmentJob.hpp"

/** Synchronous operation that gives shutdown command.
 *
 */
class ShutdownWorkerOperation : public SyncOperation  {
public:
  /// Constructor for class ShutdownWorkerOperation.
  ShutdownWorkerOperation(Connection &_connection) :
    SyncOperation(std::string("shutdown"),_connection) {}
  /// Destructor for class ShutdownWorkerOperation
  ~ShutdownWorkerOperation() {}

public:
  // function that implements read&writes in between connect/disconnect
  virtual void internal();

private:
  //!> static entity to indicate to clients that the queue is empty.
  static FragmentJob::ptr NoJob;
};

#endif /* FRAGMENTCONTROLLER_SHUTDOWNWORKEROPERATION_HPP_ */
